// init titles
    int numTitles = 1000; // limit. actual set in setup.
    int numTransactions, totalTransactions, totalDuration;
    int maxTransactions = 0; // of a single title
    int maxDuration = 0; // total days out for a single title
    int startTrans = 0;
    int count2005, count2006, count2007, count2008, count2009, count2010;
    
    int[] transactionsX = new int[0]; // populated at end setup
    int[] transDuration = new int[0]; // days out single transaction
    int[] titleDuration = new int[0]; // days out title total
    
    bookTitle[] bookTitles = new bookTitle[numTitles];
    Table titlesTable;
    Table transactionsTable;

// tooltips
    float closestDist, closestX, closestY;
    int closestIndex = -1;
    int hotspotW = 16;
    int hotspotH = 14;
    int totaldays;
    boolean y05, y06, y07, y08, y09, y10;
    int yearFilter;

// init layout & color variables
    int labelY, colX, labelH, marginX, marginY, yAnchor;
    int titleLow, titleHigh;
    
    int radiusBase = 2; 
    int radiusMax = 72; 
    
    int colorH, colorS, colorB, colorA, colorA2, hueStart;
    int eventAlpha;
    int eventFade = 1;
    int eventAlpha2 = -20;
    int eventFade2 = -1;
    boolean showEvents = true; 

// misc
    PFont fontA, fontB, fontC, fontD;
    int dataMin = int(MAX_FLOAT);
    int dataMax = int(MIN_FLOAT);


void setup() {
  
  // setup canvas
  size(1100,700);
  // frameRate(30);
  background(0);
  smooth();
  noStroke();
    
  // setup color
  colorMode(HSB,100);
  hueStart = 17; // cool color
  colorS = 50;
  colorB = 100;
  colorA = 14; // line
  colorA2 = 18; // anchor 
  eventAlpha = 0;
  
  // setup fonts
  fontA = loadFont("TrebuchetMS-Bold-14.vlw");
  fontB = loadFont("MyriadPro-Semibold-14.vlw");
  fontC = loadFont("MyriadPro-Light-12.vlw");
  fontD = loadFont("MyriadPro-Bold-24.vlw");
  
  
  textFont(fontB);
  textAlign(CENTER) ;

  // layout variables
  colX = width/7; // 6 years + margins
  marginX = colX/2; // margin inside canvas
  marginY = 40; // margin inside canvas
  labelY = height-25;
  labelY = height-75;
  labelH = 30; // height of label bar
  yAnchor = labelY - labelH/2 - 5; // x axis
  titleLow = marginY;
  titleHigh = height - marginY * 3;

  
  // setup up titles table
  titlesTable = new Table("titles.tsv");
    numTitles = titlesTable.getRowCount();
    println("titles: " + numTitles);
  transactionsTable = new Table("transactions.tsv");
    numTransactions = transactionsTable.getRowCount();
    println("transactions: " + numTransactions); 
    // double-checked below again totals from Col2 in titlesTable


  for (int i = 0; i < numTitles; i++) {
      totalDuration =  int(titlesTable.getFloat(i, 2)); 
      if (totalDuration > maxDuration) { maxDuration = totalDuration; } 
  }

  // setup titles
  for (int i = 0; i < numTitles; i++) {
    
    int thisRadius = 6;
    // int thisRadius = int(random(radiusBase*3,radiusBase*6));
    int thisRadiusMax = int(random(radiusBase*7,radiusBase*8));
    int thisRadiusMin = int(random(radiusBase,radiusBase*2));
    color thisColor = color(int(random(0,100)),30,100,80);
    int thisSpeed = int(random(1,3));

    // get title and tranaction count from titles table
    String theTitle = titlesTable.getRowName(i);
    int transactions =  int(titlesTable.getFloat(i, 1)); 
    if (transactions > maxTransactions) { maxTransactions = transactions; } 
    totalTransactions += transactions; 
    int totalDuration =  int(titlesTable.getFloat(i, 2)); 

    int anchorX = int(random(marginX,width-marginX));    
    
    int thisX = int(random(marginX*2,width-marginX*2));
    int thisY = height - marginY*3  - int( map(totalDuration,0,maxDuration,0,height-marginY*4-labelH) );
    // int thisY = int( lerp( titleLow, titleHigh, i/float(numTitles) ) ); // set y in steps. tables must be sorted. doing most to least for natural z-index stack.
    
    println(transactions + "; " + theTitle + "; Start: " + startTrans + "; Total: " + totalTransactions + "; Days out: " + totalDuration);

    bookTitles[i] = new bookTitle( 
      thisX, thisY, thisY-thisRadius*2, 
      thisRadius, thisRadiusMax, thisRadiusMin, 
      thisColor, thisSpeed, 
      anchorX, 
      theTitle, transactions, startTrans,
      totalDuration
      );
    
    // advance next title's staring point
    startTrans = totalTransactions + 1;

  }
  
  // double check transactions
  println("\ntrans by title: " + totalTransactions);
  
  
  // setup transaction anchors
  if ( numTransactions == totalTransactions ) { 
    
      println("transactions OK"); 
      println("max transaction per title: " + maxTransactions);
  
      // gather transaction day & set min/max
      for (int i = 0; i < numTransactions; i++) {
         // int anchorX = int(random(marginX,width-marginX));   
        int anchorX = int(transactionsTable.getFloat(i, 0));
        transactionsX = append(transactionsX, anchorX);
        int anchorD = int(transactionsTable.getFloat(i, 1));
        transDuration = append(transDuration, anchorD);

        
        // set min & max day
        if (anchorX > dataMax) { dataMax = anchorX; }
        if (anchorX < dataMin) { dataMin = anchorX; }
        
      }
      println( "day min: " + dataMin + "\nday max: " + dataMax );
      // println( "#199: " + transactionsX[199] ); // last money troubles
      // println( "#200: " + transactionsX[200] ); // first solve your
      
      
      // before map
      // println("before: " + transactionsX[100]);

      for (int i = 0; i < numTransactions; i++) {
         // int anchorX = int(random(marginX,width-marginX));   

        transactionsX[i] = int(map(transactionsX[i], dataMin, dataMax, 0+marginX, width-marginX));       
        
      }
      
      // after map
      // println("after: " + transactionsX[100]);
      // println(int(map(dataMax, dataMin, dataMax, 0+marginX, width-marginX)));

  }  
} // END setup

void draw() {
  
    // background: use the alpha channel of rect to produce slight trails
    fill(0,0,0,100);
    rect(0,0,width,height);
    
    // draw objects
    for (int i = 0; i < numTitles; i++) {
        // bookTitles[i].updatePosition();
        // bookTitles[i].updateRadius();
        bookTitles[i].drawLines(); 
        bookTitles[i].drawTitle(); 
        bookTitles[i].tooltip(); 
    }

    // check mouse position
    findClosestTitle();
    
    // draw labels below
    drawLabels();
    drawKey();
    drawEvents();

    textAlign(CENTER);
    rectMode(CORNER);
    
    // tooltip - set closestDistance out of the frame
/*    closestDist = width*height;
    closestX = width*height;
    closestY = width*height;*/

} // END draw


void findClosestTitle() {

  closestDist = Integer.MAX_VALUE;  // not to impose another multiplication to CPU
  closestX = Integer.MAX_VALUE;
  closestY = Integer.MAX_VALUE;
  closestIndex = -1;
  
  for (int i = 0; i < numTitles; i++) {
    
          bookTitles[i].colorOn=false;  //reset colorOn for all
          bookTitles[i].titleW = int( textWidth(bookTitles[i].theTitle) ); // width of text
          
          int h = hotspotH;
          int w = hotspotW; // fall back
              w = bookTitles[i].titleW;
          int x = bookTitles[i].titlePosX + w/2;
          int y = bookTitles[i].titlePosY - 9;
          // rectMode(CENTER); fill(50,80,80,50); rect(x,y,h,w); // VIEW HOTSPOT
        
          float d = dist(x, y, mouseX, mouseY);
          float dx = dist(x, 0, mouseX, 0);
          float dy = dist(0, y, 0, mouseY);
        
          if ( (dx < w/2) && (dy < h/2) && (d < closestDist)  ) {
              
                  // println(bookTitles[i].theTitle);
                  // println("dist:" + closestDist + " x:" + closestX + " y:" + closestY);
                  closestDist = d;
                  closestX = dx;
                  closestY = dy;
                  closestIndex = i;  // set the closest yet index to i
          }
                  
  }
  // turn on tooltip
  if(closestIndex >= 0) {
    bookTitles[closestIndex].colorOn=true;
  }
} 

void drawLabels() {
    // println("drawLabels");
 
    textFont(fontB);
    
    // background for year labels
    rectMode(CENTER);
    noStroke();
    fill(20,10,100,10);
    // rect(width/2,labelY,width,labelH);
    stroke(0,0,100,30);
    line(0,yAnchor,width,yAnchor);

    // draw year labels
    noStroke();
    int yearY = labelY +4;
    for(int i = 2005; i < 2012 ; i++) {
      
        // create hotspot
        float labelWidth = textWidth("2005");
        //float x1 = colX * (i-2004) - colX/2 - labelWidth/2;
        //float x2 = colX * (i-2004) - colX/2 + labelWidth/2;
        float x1 = colX * (i-2004) - colX/2 - labelWidth/2 -5;
        float x2 = colX * (i-2004);
                
        if ( mouseX >  x1 && mouseX <  x2 && mouseY > yearY-14 && mouseY < yearY+6 ) {     
            fill(0,0,100,100);
            yearFilter = i - 2004; // used by drawLines to brighten current year
        } else { 
            fill(0,0,100,60); 
          }
        // draw label
        text(i, colX * (i-2004) - colX/2, yearY);
        
        // turn off highlight by year. it's sticky.
        if ( mouseY < labelY || mouseY > yearY + 10 ) { 
            yearFilter = 0; 
          }

    }
    

    // draw tick marks
    stroke(0,0,100,30);
    for(int i = 0; i < 8 ; i++) {
      int x = marginX + colX * i;
      line(x, yAnchor, x, yAnchor + 10);
    }

  textAlign(LEFT);
  textFont(fontD);
  fill(0,0,100,25);
  text("dewey 346.73077-078",width-marginX*4,30);


} // END drawLabels()


void drawKey() {
    
    // setup key
    int keyStart = width - marginX*4;
    int keyX = keyStart;
    int keyY = marginY; 
    int keyW = 1;
    int keyH = 15;
    int keyStep = 4;
    int thisHue = hueStart;   
    rectMode(CORNER);
    noStroke();
    
    // draw key color
    for(int i=0; i < maxTransactions; i=i+keyStep) {
        thisHue = int(map(hueStart + i, 0, maxTransactions, hueStart, 100 + hueStart)); // map to HSB, but we will wrap around
              if ( thisHue > 100 ) { 
                  thisHue = thisHue - 100; // wrap around
               }
        keyX = (keyStart) + (keyW * i);
        fill(thisHue,colorS,colorB,40);
        rect(keyX, keyY, keyW, keyH);      
    }
    
    // show loabels
    if ( mouseX > keyStart && mouseX < keyStart + maxTransactions && mouseY > keyY && mouseY < keyY + keyH ) {
        fill(0,0,100,60);
        textFont(fontC);
        textAlign(LEFT);
        text("1", keyStart, marginY+30);
        textAlign(RIGHT);
        text(maxTransactions, keyStart+maxTransactions, marginY+30);
        textAlign(CENTER);
        text("Transactions", keyStart+maxTransactions/2, marginY+30);    
    }
    
    
} // END drawKey()


void drawEvents() {
    // println("drawEvents");
        textFont(fontC);
        textAlign(LEFT) ;
        fill(0,0,100,75);
        stroke(0,0,100,50);

        int ytext, xtext, eDay;
        int yA = 35; int yB = 50; int yC = 65;
        /*
            map timeline to canvas
            eDay = 9; // month * 30 + day
            // map (event day number, from mid 2004, to mid 2011, from 0px, to width)
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
        */
     

    for(int i = 2005; i < 2012 ; i++) {
        if( yearFilter == 1 ){ // 2005
            // foreclosure
            eDay = 315; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yA;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("Booming housing market halts abruptly, median prices drop 3.3 percent", xtext-2, yAnchor + ytext+12);
     
            // foreclosure
            eDay = 270; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yC;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("846,982 properties in foreclosure", xtext-2, yAnchor + ytext+12);
         }      
        if( yearFilter == 2 ){ // 2006
        
        
            // home construction 
            eDay = 225; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yC;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("U.S. home construction is down over 40%", xtext-2, yAnchor + ytext+12);
            // foreclosures 
            eDay = 315; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yA;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("1,259,118 foreclosures were filed during 2006", xtext-2, yAnchor + ytext+12);
         }
        if( yearFilter == 3 ){ // 2007
            // subprime lenders  
            xtext = colX*3 - colX/2 + 50;
            ytext = yC;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("Several subprime lenders declare bankruptcy", xtext-2, yAnchor + ytext+12);
            
            // sales  
            xtext = colX*4 - colX/2 - 10;
            ytext = yB;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("Largest drop in existing home sales in 25 years", xtext-2, yAnchor + ytext+12);
         }
        if( yearFilter == 4 ){ // 2008
            // SEC Ban 7 Mar 2008
            eDay = 67; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yC;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("SEC Proposes Ban on Naked Short Sales", xtext-2, yAnchor + ytext+12);

            // fannie  7 sep 2008
            eDay = 247; // month - 1 * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yB;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("Federal takeover of Fannie Mae and Freddie Mac", xtext-2, yAnchor + ytext+12);

            // bailout
            eDay = 273; // month - 1 * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = yA;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("Bailout: Emergency Economic Stabilization Act", xtext-2, yAnchor + ytext+12);
         }
        if( yearFilter == 5 ){ // 2009
            // unemployment  10 jan 2009
            eDay = 9; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = 65;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("US unemployment rises to 7.2%", xtext-2, yAnchor + ytext+12);
            // unemployment  9 apr 2009
            eDay = 99; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = 50;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("Wells Fargo reports record profit", xtext-2, yAnchor + ytext+12);
            // unemployment  1 jun 2009
            eDay = 151; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = 35;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            text("General Motors declares bankruptcy", xtext-2, yAnchor + ytext+12);
         }
        if( yearFilter == 6 ){ // 2010
            // citigroup profit 19 apr 2010
            eDay = 109; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            textAlign(LEFT); ytext = 50;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            xtext +=2;
            text("Citigroup posts $4.4B earnings", xtext-2, yAnchor + ytext+12);

            // goldman sachs fraud 16 apr 2010
            eDay = 106; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = 35;
            line(xtext, yAnchor, xtext, yAnchor + ytext);
            textAlign(RIGHT); xtext +=2;
            text("SEC charges Goldman Sachs with fraud", xtext-2, yAnchor + ytext+12);

            // home sales bottom 75 aug 2010
            eDay = 237; // month * 30 + day
            xtext = int( map( yearFilter * 365 + eDay, 180, 365*7+180, 0, width ) );
            ytext = 50;
            //line(xtext, yAnchor, xtext, yAnchor + ytext);
            textAlign(RIGHT); xtext +=4;
            //text("New home sales hit lowest levels on record", xtext-2, yAnchor + ytext+12);
        
        
         }
        
      
    } // END for()




} // END drawEvent()



