class bookTitle {
  
  // Properties
  int titlePosX, titlePosY, titleMaxY, titlePosXinit, titlePosYinit, titleW;
  int titleRadius, titleRadiusMax, titleRadiusMin;
  color titleColor, strokeColor = color(100,0,100,10);
  int xSpeed = 2, ySpeed = 2, rSpeed = 1;
  int xAnchor;
  String theTitle;
  int numTransactions, startTrans, totalDuration;
  boolean colorOn = false;
  color thisColor = color(0,0,colorB,10);
  
 
  // Constructor
  bookTitle(
    int x,int y, 
    int maxY, int r, int rMax, int rMin, 
    color cFill, 
    int speed, 
    int xAnchor, 
    String theTitle, int numTransactions, int startTrans,
    int totalDuration
    ) {
        
        this.titleRadius = r;
        this.titleRadiusMax = rMax;
        this.titleRadiusMin = rMin;
    
        this.strokeColor = color(100,0,100,10);
        // line hue below. sat, bal, alpha in setup
        // anchor circle hue below. sat, bal, alpha in setup
        this.titleColor = color(100,0,100,60); // changed below
        
    
        this.titleMaxY = maxY;
    
        this.xSpeed = speed;
        this.ySpeed = speed;
        this.rSpeed = 1;
        
        this.xAnchor = xAnchor;
    
        this.theTitle = theTitle;
        this.numTransactions = numTransactions;
        this.startTrans = startTrans;
        this.totalDuration = totalDuration;

        this.titlePosX = x;
        this.titlePosY = y;
        this.titlePosYinit = y;

  } // END bookTitle()

  // Methods
  
  void drawTitle() {
           
    // 
    int titleAlpha = 50;        
    if ( colorOn ) { titleAlpha = 80; } 
    this.titleColor = color(100,0,100,titleAlpha); // changed below
    this.titlePosX = transactionsX[startTrans]-5;

    // draw title
    textFont(fontB);
    fill(this.titleColor);
    textAlign(LEFT);
    // text(this.theTitle, transactionsX[startTrans]-5, this.titlePosY-5);
    text(this.theTitle, this.titlePosX, this.titlePosY-5);
    textAlign(CENTER);
    
    // setup & draw tooltip        
    // tooltip(  );

  } // END drawTitle
  
  
  void tooltip() {
  
       /*   this.titleW = int( textWidth(this.theTitle) ); // width of text
          
          int h = hotspotH;
          int w = hotspotW;
            w = this.titleW;
          int x = this.titlePosX + w/2;
          int y = this.titlePosY - 9;
          // rectMode(CENTER); fill(50,80,80,50); rect(x,y,h,w); // VIEW HOTSPOT
        
          float d = dist(x, y, mouseX, mouseY);
          float dx = dist(x, 0, mouseX, 0);
          float dy = dist(0, y, 0, mouseY);
        
          if ( (dx < w/2) && (dy < h/2) && (d < closestDist)  ) {
              
                  closestDist = d;
                  closestX = dx;
                  closestY = dy;
// tooltip buggy
// d < closestDist shouldn't be true for more than one title
// println("dist:" + closestDist + " x:" + closestX + " y:" + closestY);
                  
                  // turn color On or Off
                  this.colorOn = true;
                
                  // to draw text related to closest item.
                  if (closestDist != width*height) {
                          // tooltip background
                          
                          rectMode(CORNER);
                          fill(0,0,95,75); 
                          rect(this.titlePosX-7, this.titlePosY-62, this.titleW + 14, 66);
                          // tooltip text
                          fill(0,0,0,100);
                          textAlign(CENTER);
                          textAlign(LEFT);
                          text("Transaction: " + this.numTransactions, this.titlePosX, this.titlePosY-45);
                          text("Days out: " + this.totalDuration, this.titlePosX, this.titlePosY-25);
                          text(this.theTitle, this.titlePosX, this.titlePosY-5);
  
                          // cursor(HAND); 
                  } else { 
                            // cursor(ARROW); 
                    }
          } // END if closestDist
          else {
              this.colorOn = false; 
          }*/
          
          if (colorOn==true) {
                          // tooltip background
                          
                          rectMode(CORNER);
                          fill(0,0,95,75); 
                          rect(this.titlePosX-7, this.titlePosY-62, this.titleW + 14, 66);
                          // tooltip text
                          fill(0,0,0,100);
                          textAlign(CENTER);
                          textAlign(LEFT);
                          text("Transaction: " + this.numTransactions, this.titlePosX, this.titlePosY-45);
                          text("Days out: " + this.totalDuration, this.titlePosX, this.titlePosY-25);
                          text(this.theTitle, this.titlePosX, this.titlePosY-5);
  
                          // cursor(HAND); 
                  } 
          
          
  } // END tooltip

  
  void drawLines() {
      
      // draw line
      int originX = transactionsX[startTrans];
      int stopTrans = startTrans + numTransactions;
      // println(startTrans + " + " + numTransactions + " = " + stopTrans + " of " + totalTransactions );
  
      // using transactionsX[] draw a line for each numTransactions
      for (int i = startTrans; i < stopTrans-1; i++) {
        
            // shift color by for each transaction
            int thisHue = i - startTrans; // start from 0
            thisHue = int(map(thisHue, 0, maxTransactions, hueStart, 100 + hueStart)); // map to HSB, but we will wrap around
            if ( thisHue > 100 ) { 
                thisHue = thisHue - 100; // wrap around
             }
    
            int colorAlpha = 4; // base brightness
            
            // brighten on title hover
            if ( colorOn ) { colorAlpha = 20; } 

            // brighten on year hover
            for(int k = 2005; k < 2012 ; k++) {
                    int thisColx1 = colX * (k-2004) - colX/2;
                    int thisColx2 = colX * (k-2004) + colX/2;

                    if ( transactionsX[i] >  thisColx1  && transactionsX[i] <  thisColx2 && yearFilter == k-2004 ) {
                        colorAlpha = 20;
                    } 
             }

            // set color
            color thisColor = color(thisHue,colorS,colorB,colorAlpha);
            stroke(thisColor);
            
            // draw line
            line(originX, this.titlePosY,transactionsX[i],yAnchor);
            
            // bottom circles = transaction length
            if ( mouseY > yAnchor-5 && mouseY < yAnchor+5 ) {
    
                  int thisRadius = radiusBase;
                  if ( transDuration[i] < 366 ) { thisRadius = int( map( transDuration[i], 0, 365, width/(7*365), width/7 ) ); }
                  if ( transDuration[i] > 365 ) { thisRadius = width/7; }
    
                  noFill();
                  thisColor = color(thisHue,colorS,colorB,colorA2/2);
                  stroke(thisColor);
                  ellipseMode(CORNER);
                  ellipse( transactionsX[i], yAnchor-thisRadius/2, thisRadius, thisRadius); 
                  ellipseMode(CENTER); 
            }

            noStroke();
          
       } // END for loop thru transaction
      noStroke();
  
  } // END drawLines
  
  
  

  
 
  void updateRadius() {

    if( (this.titleRadius > this.titleRadiusMax) || (this.titleRadius < this.titleRadiusMin) ) {
          this.rSpeed = -this.rSpeed;
     }
    this.titleRadius += this.rSpeed;
    
  } // updateRadius
 
  
  
  void updatePosition() {
    
    this.titlePosX = transactionsX[startTrans]-5;
    
    //update X pos
    if( (this.titlePosX > this.titlePosXinit + 4) || (this.titlePosX < this.titlePosXinit - 4) ) {
        this.xSpeed = -this.xSpeed;
    }

    // update Y pos
    if( (this.titlePosY > this.titlePosYinit + 4) || (this.titlePosY < this.titlePosYinit - 4) ) {
        this.ySpeed = -this.ySpeed;
    }


    // move it
    this.titlePosX += this.xSpeed;
    this.titlePosY += this.ySpeed;
    

  } // end updatePosition
}
